/* queue.h - header for queue package */
#ifndef QUEUE_H
#define QUEUE_H
#include "local.h"
#include "pointer.h"
#define Q_NODE struct q_node
Q_NODE
	{
	Q_NODE *next;
	/* ... */
	};

void q_append();	/* PARMS(Q_NODE **frontp, Q_NODE **rearp, Q_NODE *p) */
void q_close();		/* PARMS(Q_NODE **frontp, Q_NODE **rearp) */
void q_insert();
	/* PARMS(Q_NODE **frontp, Q_NODE **rearp, Q_NODE *p, int (*cmpfn)()) */
Q_NODE **q_lfind();
	/* PARMS(Q_NODE **frontp, Q_NODE **rearp, Q_NODE *p, int (*cmpfn)()) */
Q_NODE *q_pop();	/* PARMS(Q_NODE **frontp, Q_NODE **rearp) */
void q_push();		/* PARMS(Q_NODE **frontp, Q_NODE **rearp, Q_NODE *p) */
Q_NODE *q_r_detach();
	/* PARMS(Q_NODE **frontp, Q_NODE **rearp, Q_NODE **pp) */
void q_r_insert();
	/* PARMS(Q_NODE **frontp, Q_NODE **rearp, Q_NODE *p, Q_NODE **pp) */

/* (more)
.PE
.PS 20
 */

#define Q_PP(p)		PNNC(p, Q_NODE **)
#define Q_P(p)		PNNC(p, Q_NODE *)

#define Q_APPEND(fp, rp, p)		q_append(Q_PP(fp), Q_PP(rp), Q_P(p))
#define Q_CLOSE(fp, rp)			q_close(Q_PP(fp), Q_PP(rp))
#define Q_INSERT(fp, rp, p, fn)	q_insert(Q_PP(fp), Q_PP(rp), Q_P(p), fn)
#define Q_LFIND(fp, rp, p, fn)	q_lfind(Q_PP(fp), Q_PP(rp), Q_P(p), fn)
#define Q_POP(fp, rp)			q_pop(Q_PP(fp), Q_PP(rp))
#define Q_PUSH(fp, rp, p)		q_push(Q_PP(fp), Q_PP(rp), Q_P(p))
#define Q_R_DETACH(fp, rp, pp)	q_r_detach(Q_PP(fp), Q_PP(rp), Q_PP(pp))
#define Q_R_INSERT(fp, rp, p, pp) q_r_insert(Q_PP(fp), Q_PP(rp), Q_P(p), Q_PP(pp))

#define Q_IS_EMPTY(front)       ((front) == NULL)
#define Q_OPEN(frontp, rearp)   (*(frontp) = *(rearp) = NULL)
#define Q_NEXT(p)               ((p)->next)
#define EACH_Q(front, p)        for ((p) = front; (p) != NULL; p = (p)->next)
#endif
